<?xml version="1.0" encoding="UTF-8"?>
<flow xmlns="http://www.springframework.org/schema/webflow"
      xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
      xsi:schemaLocation="http://www.springframework.org/schema/webflow http://www.springframework.org/schema/webflow/spring-webflow-2.4.xsd">

    <var name="author" class="com.realdolmen.spring.blog.domain.Author"/>
    <var name="blog" class="com.realdolmen.spring.blog.domain.Blog"/>

    <view-state id="register" view="registration/register" model="author">
        <transition on="next" to="blog">
            <evaluate expression="blog.author = author" />
        </transition>
    </view-state>

    <view-state id="blog" view="registration/blog" model="blog">
        <transition on="previous" to="register" validate="false"/>
        <transition on="next" to="confirm"/>
    </view-state>

    <view-state id="confirm" view="registration/confirm">
        <transition on="edit" to="register"/>
        <transition on="confirm" to="save"/>
    </view-state>

    <action-state id="save">
        <evaluate expression="registrationService.save(flowScope.author, flowScope.blog)"/>
        <transition on-exception="com.realdolmen.spring.blog.error.AuthorExistsException" to="register">
            <set name="flashScope.error" value="'User already exists!'"/>
        </transition>
        <transition to="end"/>
    </action-state>

    <end-state id="end" view="externalRedirect:/login"/>

</flow>